Description

Now that | have most of my web-based servers switched over to FreeBSD using the popular open source FreeNAS variant of
FreeBSD. FreeNAS supports Jails, which are lightweight para-virtualized environments, that allows for numerous separate servers to
live on a single machine, utilizing the same kernel. | need a full virtualization solution however, this is where VirtualBox comes in.

reported to

NOTE: As of FreeNAS 9.2.1.6-BETA, there is a VirtualBox template that installs all the necessary packages and kernel modules from
the Jails type section, while creating new jails. This should be stable by the next STABLE release.

cd /path/to/modules
mount -uw /

cp *.ko /boot/kernel/
mount -r /

¢ Enablethe kernel-modules

kldload vboxdrwv
kldload vboxnetflt
kldload vboxnetadp
Create a new Jail for the VirtualBox Host
Now create a Jail by going to Jails -> Add Jail, and configure the Jail accordingly. | chose to use a Standard Jail Type in order to
stick to the barest possible FreeBSD installation. Once the Jail is finished installing, open the VirtualBox Jail shell and enable and
start SSH, create new root SSH key, set root password, add a new privileged user and then close the web shell. | won't go into detail
on how to do this, since it is cover in Issue #329

* When the initial configuration is done, log into the jail using ssh:

ssh user@examplejail.com
e Update the Jails packages and ports tree:

pkg upgrade && portsnap fetch extract

e Add a standard user for VirtualBox to be ran as

SuperSecretPassword
SuperSecretPassword
[Enter]

yes

no

e Now install VirtualBox

pkg install virtualbox-ose

e Add the standard user to the VirtualBox Users group

pw groupmod vboxusers -m bob

Enable Network Bridging Support

echo 'vboxnet_enable="YES"' >> /etc/rc.conf

°

Now at this point, log back into FreeNAS and reboot it.

(Method 1) Create the VirtualBox VM

Since this is a headless (No GUI) installation, the VirtualBox machine must be created from the command line.
e Create a Windows 7 64-bit machine

VBoxManage createvm —--name "Windows 7" —--register

VBoxManage modifyvm "Windows 7" --ostype Windows7_64 —--memory 2048 --ioapic on --pae on —--hwvi
rtex on

VBoxManage modifyvm "Windows 7" --nicl bridged —--bridgeadapterl epairOb

NOTE: | needed to use the interface provided to the jail, which can be found using ifconfig.

e Create the Virtual hard drive

VBoxManage createhd —--filename /home/user/VirtualBox\ VMs/Windows\ 7/virtualmachine-diskl.vmdk
—--size 10000

e Use a virtual hard drive from a .ova file

| had a snag trying to import an OVA directly, luckily .ova files are just simple tar archives and can be extracted like so:

tar xvf /path/to/virtualmachine.ova
Once the OVA has been extracted, there will be a few files:

1. virtualmachine.ovf - The virtualmachine manifest file
2. virtualmachine-disk1.vmdk - The virtualmachine hard drive
3. virtualmachine.mf - A file containing the SHA1 checksums of the above two files

The virtual hard drive can be moved to the VirtualBox machine folder

mv /path/to/virtualmachine-diskl.vmdk /home/user/VirtualBox\ VMs/Billing\ VM/

e Attach the Virtual hard drive to the Windows 7 host

VBoxManage storagectl "Windows 7" —-—-name "IDE Controller" --add ide
VBoxManage storageattach "Windows 7" —--storagectl "IDE Controller" --port 0 —--device 0 —-type
hdd --medium /home/user/VirtualBox\ VMs/Billing\ VM/virtualmachine-diskl.vmdk

(Method 2) Import Virtual Machine using existing OVA

This can easily be done by using the VBoxManage command:

VBoxManage import Windows7.ova

NOTE: Make sure the user is a part of the vboxusers group:

pw groupmod vboxusers -m exampleuser

NOTE: When transferring large files make sure to check the sha256 sum on both ends.
Start the Virtual Machine

® Once the VM is created or imported, it can be started using:

VBoxHeadless —--startvm "Windows 7"

e NOTE: | needed to upgrade the packages in the Jail, so after ssh and logging in as root:
pkg lock virtualbox-ose-kmod
pkg update
pkg upgrade
e NOTE: When | launched the Guest VM, | received the following error:
VBoxManage: error: Implementation of the USB 2.0 controller not found!
VBoxManage: error: Because the USB 2.0 controller state is part of the saved VM state, the VM cannot be started. To fix this
problem, either install the 'Oracle VM VirtualBox Extension Pack' or disable USB 2.0 support in the VM settings

(VERR_NOT_FOUND)
VBoxManage: error: Details: code NS_ERROR_FAILURE (0x80004005), component Console, interface IConsole

| decided to turn off USB2.0 support, as | will not actually be needing USB remotely (though remote USB should be possible):

VBoxManage modifyvm "Windows 7" —--usb off
* NOTE: When | went to relaunch the VM, | received the following error:
VBoxManage: error: Failed to open/create the internal network 'HostInterfaceNetworking-Realtek PCle GBE Family Controller'
(VERR_INTNET_FLT_IF_NOT_FOUND).

VBoxManage: error: Failed to attach the network LUN (VERR_INTNET_FLT_IF_NOT_FOUND)
VBoxManage: error: Details: code NS_ERROR_FAILURE (0x80004005), component Console, interface IConsole

| decided to switch the virtual network card from gigabit (support on the extension pack) to 100M:

VBoxManage modifyvm "Windows 7" —--nictypel 82540EM

VBoxManage modifyvm "Billing VM" --bridgeadapterl epairOb

NOTE: Make sure the correct interface is bridged. This can be found using ifconfig.

| still needed to access the VirtualBox GUI to finish installing Windows. Luckily | did not need RDP or VNC, | only needed to forward

X over SSH. | logged on with the -X option and opened VirtualBox:

ssh —-X user@examplehost.com
VirtualBox

Automatically Start Virtual Machine at Boot

| need to have the VM start when the NAS boots, so | needed to add the following to /etc/rc.conf:
vboxheadless_enable="yes"
vboxheadless_machines="vm0"

vboxheadless_vmO0_name="3c5f7875-ca0f-494a-9¢81-dc29d8119666"
vboxheadless_vmO0_user="bob"

Resources

e https://bugs.freenas.org/issues/1974

History

#1 - 06/12/2014 08:37 AM - Daniel Curtis

- Description updated

#2 - 06/12/2014 12:41 PM - Daniel Curtis

- Description updated

07/11/2025 4/5



https://bugs.freenas.org/issues/1974

#3 - 06/18/2014 08:59 AM - Daniel Curtis
- Description updated

#4 - 06/18/2014 10:56 AM - Daniel Curtis
- Description updated

#5 - 06/19/2014 12:21 PM - Daniel Curtis
- Description updated

#6 - 06/19/2014 12:41 PM - Daniel Curtis
- Description updated

- Status changed from In Progress to Resolved

#7 - 06/19/2014 01:18 PM - Daniel Curtis
- Description updated

- Status changed from Resolved to Closed

#8 - 02/15/2015 08:44 PM - Daniel Curtis
- Project changed from 88 to FreeBSD Administration
- Category set to Jails / Containers

- Target version set to FreeNAS 9.x
